freeslot("MT_SERPENTINE_FIRE", "MT_SERPENTINE_FIRE2", "MT_SERPENTINE_FIREEXHOOST", "S_SERPENTINE_FIRE", "S_SERPENTINE_FIRE2", "sfx_srpbr",
"S_PLAY_SERPENTINE_FIRE1", "S_PLAY_SERPENTINE_FIRE2", "S_PLAY_SERPENTINE_FIRE3", "S_PLAY_SERPENTINE_FIRE4", "S_PLAY_SERPENTINE_FIRE5",
"S_PLAY_SERPENTINE_FIRE6",
"S_PLAY_SERPENTINE_FLYFIRE1", "S_PLAY_SERPENTINE_FLYFIRE2", "S_PLAY_SERPENTINE_FLYFIRE3", "S_PLAY_SERPENTINE_FLYFIRE4", "S_PLAY_SERPENTINE_FLYFIRE5",
"S_PLAY_SERPENTINE_FLYFIRE6", "S_PLAY_SERPENTINE_FUCK1", "S_PLAY_SERPENTINE_FUCK2", "S_PLAY_SERPENTINE_FUCK3", "S_PLAY_SERPENTINE_ULTRA_FIRE1",
"S_PLAY_SERPENTINE_ULTRA_FIRE2", "S_PLAY_SERPENTINE_ULTRA_FIRE3", "S_PLAY_SERPENTINE_ULTRA_FIRE4", "S_PLAY_SERPENTINE_ULTRA_FIRE5", 
"S_PLAY_SERPENTINE_ULTRA_FIRE6", "SPR_CANC", "S_SERPENTINE_SHIELD", "S_PLAY_SERPENTINE_DASH1", "S_PLAY_SERPENTINE_DASH2", "S_PLAY_SERPENTINE_DASH3",
"MT_SERPENTINE_ROCKET", "S_SERPENTINE_ROCKET", "S_SERPENTINE_ROCKET", "SPR_SERP", "S_PLAY_SERPENTINE_ROCKET1", "S_PLAY_SERPENTINE_ROCKET2",
"S_PLAY_SERPENTINE_ROCKET3", "S_PLAY_SERPENTINE_ROCKET4", "S_PLAY_SERPENTINE_ROCKET5", "S_PLAY_SERPENTINE_ROCKET6", "S_PLAY_SERPENTINE_ROCKET7",
"S_PLAY_SERPENTINE_ROCKET8", "S_PLAY_SERPENTINE_ROCKET9", "S_PLAY_SERPENTINE_ROCKET10", "S_PLAY_SERPENTINE_ROCKET11", "sfx_spex1", "sfx_spex2",
"sfx_srplg1", "sfx_srpbr2", "sfx_srplg2", "sfx_srplg3", "sfx_srp1", "sfx_srp2", "sfx_srp3", "sfx_srp4", "sfx_srp5", "sfx_srp6", "sfx_srp7",
"sfx_srp8", "sfx_srp9", "sfx_srp10", "sfx_srp11", "sfx_srp12", "sfx_srp13", "sfx_srp14", "sfx_srp15", "sfx_srp16", "sfx_srp17", "sfx_srp18",
"sfx_srp19", "sfx_srp20", "sfx_srp21", "sfx_srpht1", "sfx_srpht2", "S_PLAY_DASHRUN_SERPENTINE", "sfx_spex3", "S_SERPENTINE_ROCKET_EXPLODE",
"sfx_srp22", "S_SERPENTINE_DUST", "SPR_SRPB"
)

states[S_SERPENTINE_DUST] = {
	sprite = SPR_SRPB,
	frame = A|FF_ANIMATE|TR_TRANS40,
	var1 = 7,
	var2 = 2,
	tics = 7*2,
	nextstate = S_NULL
}

states[S_PLAY_DASHRUN_SERPENTINE] = {
        sprite = SPR_PLAY,
        frame = SPR2_RUN|FF_ANIMATE,
        tics = 35,
        var1 = 2,
        var2 = 1,
        nextstate = S_PLAY_FALL
}

mobjinfo[MT_SERPENTINE_ROCKET] = {
	spawnhealth = 69,
	radius = 12*FRACUNIT,
	height = 24*FRACUNIT,
	speed = 60*FRACUNIT,
	deathsound = sfx_spex3,
	flags = mobjinfo[MT_TURRETLASER].flags,
	spawnstate = S_SERPENTINE_ROCKET,
	deathstate = S_SERPENTINE_ROCKET_EXPLODE
}

states[S_SERPENTINE_ROCKET_EXPLODE] = {
	sprite = SPR_SERP,
	frame = A,
	tics = 1,
	var1 = 1,
	var2 = 1,
	action = A_RingExplode,
	nextstate = S_TNTBARREL_EXPL1
}

states[S_SERPENTINE_ROCKET] = {
	sprite = SPR_SERP,
	frame = A,
	tics = 1,
	var1 = 60*FRACUNIT,
	var2 = 1,
	action = A_HomingChase,
	nextstate = S_SERPENTINE_ROCKET
}

states[S_SERPENTINE_SHIELD] = {
	sprite = SPR_CANC,
	frame = A|FF_ANIMATE,
	var1 = 11,
	var2 = 3,
	tics = 12,
	nextstate = S_NULL,
}

mobjinfo[MT_SERPENTINE_FIRE] = {
	spawnstate = S_SERPENTINE_FIRE,
	spawnhealth = 69,
	radius = 12*FRACUNIT,
	height = 24*FRACUNIT,
	flags = mobjinfo[MT_TURRETLASER].flags,
}

mobjinfo[MT_SERPENTINE_FIRE2] = {
	spawnstate = S_SERPENTINE_FIRE2,
	spawnhealth = 69,
	radius = 12*FRACUNIT,
	height = 24*FRACUNIT,
	flags = mobjinfo[MT_TURRETLASER].flags,
	deathstate = S_NULL
}

mobjinfo[MT_SERPENTINE_FIREEXHOOST] = {
	spawnstate = S_SERPENTINE_FIRE,
	spawnhealth = 69,
	radius = 12*FRACUNIT,
	height = 24*FRACUNIT,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY,
}

states[S_SERPENTINE_FIRE2] = {
	sprite = SPR_THOK,
	frame = A,
	tics = -1,
	nextstate = S_SERPENTINE_FIRE2
}

local function RocketBreakedLineShatter(s, dist)
		local line = {}
		searchBlockmap("lines", function(m, linedef)
		local x,y = P_ClosestPointOnLine(m.x, m.y, linedef)
		if (R_PointToDist2(m.x, m.y, x, y) < dist)
			table.insert(line, linedef)
		else
			return
		end
	end, s, s.x-dist, s.x+dist, s.y-dist, s.y+dist)
	for i = 1, #line
		if line[i].valid
			local backfront = {line[i].frontsector, line[i].backsector}
			for d = 1, #backfront
				for fof in backfront[d].ffloors()
					if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
					and ((abs(s.z-fof.topheight) <= dist) or (abs(s.z-fof.bottomheight) <= dist))
					and ((s.type == MT_SERPENTINE_ROCKET) or not (fof.flags & FF_STRONGBUST))
						EV_CrumbleChain(nil, fof)
            		end
        		end
			end
		end
	end
end

local BulletKillerSpikes = function(thing, tmthing)
	if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if tmthing and tmthing.valid and (tmthing.type == MT_SERPENTINE_FIRE or tmthing.type == MT_SERPENTINE_FIRE2 or tmthing.type == MT_SERPENTINE_ROCKET)
	and (abs(thing.z - tmthing.z) <= 60*tmthing.scale)
		if tmthing.z >= thing.z-tmthing.height and tmthing.z <= thing.z+thing.height+tmthing.height
			P_KillMobj(thing, tmthing)
			return true
		end
	end
end

addHook("MobjCollide", function(thing, tmthing) BulletKillerSpikes(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) BulletKillerSpikes(thing, tmthing) end, MT_WALLSPIKE)

addHook("MobjThinker", function(m)
	m.sprite = SPR_THOK
	m.frame = A
	m.momx = FixedMul($, FRACUNIT*3/4)
	m.momy = FixedMul($, FRACUNIT*3/4)
	m.momz = FixedMul($, FRACUNIT*3/4)
	m.scale = FixedMul($, FRACUNIT*3/4)
	m.color = SKINCOLOR_PURPLE
	m.colorized = true
	m.blendmode = AST_ADD
end, MT_SERPENTINE_FIREEXHOOST)

addHook("MobjSpawn", function(m)
	m.color = SKINCOLOR_PURPLE
	m.colorized = true
	m.blendmode = AST_ADD
end, MT_SERPENTINE_FIREEXHOOST)

addHook("MobjSpawn", function(m)
	m.color = SKINCOLOR_PURPLE
	m.colorized = true
	m.blendmode = AST_ADD
end, MT_SERPENTINE_FIRE)

addHook("MobjSpawn", function(m)
	m.color = SKINCOLOR_PURPLE
	m.colorized = true
	m.blendmode = AST_ADD
end, MT_SERPENTINE_FIRE2)

addHook("MobjThinker", function(m)
	m.color = SKINCOLOR_PURPLE
	m.colorized = true
	m.blendmode = AST_ADD
	for i = 0,3-1 do
		local where = (FRACUNIT/3) * i
		local xx = FixedMul(m.momx, where)
		local yy = FixedMul(m.momy, where)
		local zz = FixedMul(m.momz, where)
		local E = P_SpawnMobj(m.x+xx, m.y+yy, m.z+zz+m.height/2, MT_SERPENTINE_FIREEXHOOST)
		E.momx = m.momx+xx
		E.momy = m.momy+yy
		E.momz = m.momz+zz
		E.scale = m.scale + FixedMul(FRACUNIT/16, where)
		E.fuse = 6
		E.color = SKINCOLOR_PURPLE
		E.colorized = true
		E.blendmode = AST_ADD
		E.height = m.height/2
	end
end, MT_SERPENTINE_FIRE)

addHook("MobjThinker", function(m)
	m.color = SKINCOLOR_PURPLE
	m.colorized = true
	m.blendmode = AST_ADD
	for i = 0,3-1 do
		local where = (FRACUNIT/3) * i
		local xx = FixedMul(m.momx, where)
		local yy = FixedMul(m.momy, where)
		local zz = FixedMul(m.momz, where)
		local E = P_SpawnMobj(m.x+xx, m.y+yy, m.z+zz+m.height/2, MT_SERPENTINE_FIREEXHOOST)
		E.momx = m.momx+xx
		E.momy = m.momy+yy
		E.momz = m.momz+zz
		E.scale = m.scale + FixedMul(FRACUNIT/16, where)
		E.fuse = 6
		E.color = SKINCOLOR_PURPLE
		E.colorized = true
		E.blendmode = AST_ADD
		E.height = m.height/2
	end
	if (leveltime % 11) == 1
		P_SetObjectMomZ(m, -40*FRACUNIT)
	end
end, MT_SERPENTINE_FIRE2)

addHook("ShouldDamage", function(mo, inf)
	if mo and mo.valid and mo.player
		if inf and inf.valid and inf.type == MT_SERPENTINE_ROCKET and inf.health
			if CBW_Battle
			or G_RingSlingerGametype()
				inf.state = S_SERPENTINE_ROCKET_EXPLODE
				inf.momx = 0
				inf.momz = 0
				inf.momy = 0
				P_KillMobj(inf)
				A_RingExplode(inf)
				S_StartSound(inf, sfx_spex3)
			end
		end
	end
end, MT_PLAYER)

addHook("ShouldDamage", function(mobj, inf)
	if mobj and mobj.valid 
	and (mobj.flags & (MF_ENEMY|MF_MONITOR|MF_BOSS))
		if inf and inf.valid and inf.type == MT_SERPENTINE_ROCKET and inf.health
			inf.state = S_SERPENTINE_ROCKET_EXPLODE
			inf.momx = 0
			inf.momz = 0
			inf.momy = 0
			P_KillMobj(inf)
			A_RingExplode(inf)
			S_StartSound(inf, sfx_spex3)
		end
	end
end)

addHook("MobjThinker", function(mo)
	if (mo and mo.valid)
	and mo.type == MT_SERPENTINE_ROCKET
	and mo.state == S_SERPENTINE_ROCKET
		RocketBreakedLineShatter(mo, 64*FRACUNIT)
		local serpentine_dust = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
		serpentine_dust.blendmode = AST_ADD
		serpentine_dust.state = S_SERPENTINE_DUST
		serpentine_dust.xoff = P_RandomRange(23, -23)*mo.scale
		serpentine_dust.yoff = P_RandomRange(23, -23)*mo.scale
		serpentine_dust.zoff = P_RandomRange(23, -23)*mo.scale+mo.height*P_MobjFlip(mo)/3
		serpentine_dust.scale = mo.scale+P_RandomRange(-2, 3)*mo.scale/8
		serpentine_dust.color = SKINCOLOR_SILVER
		serpentine_dust.colorized = true
		if (leveltime % 6) == 1
			P_Thrust(mo, mo.angle, 5*FRACUNIT)
		end
	end
end, MT_SERPENTINE_ROCKET)

mobjinfo[MT_SERPENTINE_ROCKET].name = "Serpentine Rocket"
mobjinfo[MT_SERPENTINE_FIRE].name = "Serpentine Blaster"
mobjinfo[MT_SERPENTINE_FIRE2].name = "Serpentine Blaster"